#!/bin/sh
# Copyright (c) 2003-2007 Erez Zadok
# Copyright (c) 2003-2007 Stony Brook University
# Copyright (c) 2003-2007 The Research Foundation of State University of New York
# Copyright (c) 2004-2007 Nikolai Joukov
# Copyright (c) 2003-2005 Akshat Aranya
# Copyright (c) 2006-2007 Gopala Surya

LOWERDIR=/n/lower
MOUNTPOINT=/n/tracefs-upper
DEBUG=0
BINDIR=../tracefs
UTILDIR=../utils
CONF=streaming_tracefs_config
export LD_LIBRARY_PATH=${UTILDIR}/generic_comp

/sbin/insmod ${BINDIR}/tracefs.ko || exit $?
mount -t tracefs -o dir=${LOWERDIR},debug=${4:-$DEBUG} none ${MOUNTPOINT} || exit $?

rm -f /n/fsl/streaming.trfs*
${UTILDIR}/tracefs-ctl/conf_mountpoint -p ${MOUNTPOINT} < $CONF
${UTILDIR}/tracefs-ctl/tracefs-ctl ${MOUNTPOINT} go 0

#
# Replace this 'ls' with the activity to trace
#
##################
#Tracing operation begins
##################

ls ${MOUNTPOINT}
cd ${MOUNTPOINT}
date > test
cp $LOWERDIR/test $LOWERDIR/test1

###################
#Tracing operation ends
####################
cd /home/gopalas/proj/tracefs/examples
${UTILDIR}/tracefs-ctl/tracefs-ctl ${MOUNTPOINT} stop 0
${UTILDIR}/tracefs-ctl/tracefs-ctl ${MOUNTPOINT} d 0

umount ${MOUNTPOINT}
/sbin/rmmod tracefs
#/sbin/rmmod kwrappers

#
# postprocessing phase
#
#${UTILDIR}/generic_comp/tracegen -f /n/fsl/streaming.trfs > /n/fsl/streaming.trfs.txt

