/*
 * Copyright (c) 2003-2007 Erez Zadok
 * Copyright (c) 2003-2007 Stony Brook University
 * Copyright (c) 2003-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2007 Gopala Surya
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */
#ifdef FISTGEN
# include "fist_tracefs.h"
#endif /* FISTGEN */
#include "fist.h"
#include "tracefs.h"
#ifdef KWRAPPERS
#include "kwrappers.h"
#endif
/* OPTIONAL CODE FOLLOWS */



int
tracefs_encode_block(const char *from, char *to, int len, const vnode_t *vp, const vfs_t *vfsp, u_long pagenum)
{
    memcpy(to, from, len);
    return len;
}


int
tracefs_decode_block(const char *from, char *to, int len, const vnode_t *vp, const vfs_t *vfsp, u_long pagenum)
{
    memcpy(to, from, len);
    return len;
}

int
tracefs_encode_filename(const char *name, int length, char **encoded_name, int skip_dots, const vnode_t *this_vnode, const vfs_t *this_vfsp)
{
        int encoded_length;

        encoded_length = length + 1;
        *encoded_name = KMALLOC(encoded_length, GFP_KERNEL);
        if (!*encoded_name) {
                printk("<0>Kernel out of memory!\n");
                ASSERT(NULL);
        }
        memcpy(*encoded_name, name, length);
        (*encoded_name)[length] = '\0';

        return encoded_length;
}

/* returns length of decoded string, or -1 if error */
int
tracefs_decode_filename(const char *name, int length, char **decoded_name, int skip_dots, const vnode_t *this_vnode, const vfs_t *this_vfsp)
{
        int error = 0;

        *decoded_name = KMALLOC(length, GFP_KERNEL);
        if (!*decoded_name) {
                printk("<0>Kernel out of memory!\n");
                ASSERT(NULL);
        }
        memcpy(*decoded_name, name, length);
        error = length;

        return error;
}


/*
 * Local variables:
 * c-basic-offset: 4
 * End:
 */
